/**
 # minimax.js
 # Implements Minimax Alpha-Beta-Pruning Algorithm to play connect4 game  
 #
 # @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 # @copyright Copyright (C) 2022 Joachim Schmidt. All rights reserved.
 # @license	 http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 #
 # change activity:
 */
 let checkboard=[["","","","","","",""],["","","","","","",""],["","","","","","",""],["","","","","","",""],["","","","","","",""],["","","","","","",""]],maxDepth=5,scores={ai:1e6,human:-1e6,tie:0},human="r",ai="b",currentPlayer=human;function getAvailableRow(c){let b;for(let a=0;a<6;a++)""==checkboard[a][c]&&(b=a);return b}function setOf(c){let a=[];for(let b of c)a.includes(b)||a.push(b);return a}function same4(a){for(let b of a)if(""==b)return!1;return 4!=a.length&&console.log(`same4: arr length is not 4 - [${a}]`),1==setOf(a).length}function checkWin(){let a;for(let o of checkboard)for(let b=0;b<4;b++)same4(o.slice(b,b+4))&&(a=o[b]);for(let g=0;g<7;g++){let h=[];for(let q of checkboard)h.push(q[g]);for(let c=0;c<3;c++)same4(h.slice(c,c+4))&&(a=h[c])}for(let d=0;d<4;d++){for(let i=3;i<6;i++){let j=[];for(let e=0;e<4;e++)j.push(checkboard[i-e][d+e]);same4(j)&&(a=j[0])}for(let k=0;k<3;k++){let l=[];for(let f=0;f<4;f++)l.push(checkboard[k+f][d+f]);same4(l)&&(a=l[0])}}let p=0;for(let m=0;m<6;m++)for(let n=0;n<7;n++)""==checkboard[m][n]&&p++;return null==a&&0==p&&(a="tie"),a}function getAvailableRow(c){let b;for(let a=0;a<6;a++)""==checkboard[a][c]&&(b=a);return b}function evalArr(e){let b=0,c=0,a=0;for(let d of e)d==ai&&b++,d==human&&c++,""==d&&a++;return 3==b&&1==a?100:2==b&&2==a?10:1==b&&3==a?1:3==c&&1==a?-100:2==c&&2==a?-10:1==c&&3==a?-1:0}function evalStaticBoard(){let a=0;for(let m of checkboard)for(let b=0;b<4;b++)a+=evalArr(m.slice(b,b+4));for(let g=0;g<7;g++){let j=[];for(let n of checkboard)j.push(n[g]);for(let c=0;c<3;c++)a+=evalArr(j.slice(c,c+4))}for(let d=0;d<4;d++){for(let h=3;h<6;h++){let k=[];for(let e=0;e<4;e++)k.push(checkboard[h-e][d+e]);a+=evalArr(k)}for(let i=0;i<3;i++){let l=[];for(let f=0;f<4;f++)l.push(checkboard[i+f][d+f]);a+=evalArr(l)}}return a}function aiMove(){let e=-1/0,b;for(let a=0;a<7;a++){let c=getAvailableRow(a);if(null!=c&&""==checkboard[c][a]){checkboard[c][a]=ai;let d;d=minimaxABP(checkboard,maxDepth,!1,-1/0,1/0),checkboard[c][a]="",d>=e&&(e=d,b={i:a,j:c})}}if(null!=b)return checkboard[b.j][b.i]=ai,b.i}function minimax(a,d,l){let k=maxDepth-d+1,e=checkWin();if(null!=e){let f;return e==human?f=scores.human:e==ai?f=scores.ai:"tie"==e&&(f=scores.tie),f-20*k}if(0==d)return evalStaticBoard()-20*k;if(l){let i=-1/0;for(let b=0;b<7;b++){let g=getAvailableRow(b);if(null!=g&&""==a[g][b]){a[g][b]=ai;let m=minimax(a,d-1,!1);a[g][b]="",i=Math.max(i,m)}}return i}{let j=1/0;for(let c=0;c<7;c++){let h=getAvailableRow(c);if(null!=h&&""==a[h][c]){a[h][c]=human;let n=minimax(a,d-1,!0);a[h][c]="",j=Math.min(j,n)}}return j}}function minimaxABP(a,f,n,b,c){let m=maxDepth-f+1,g=checkWin();if(null!=g){let h;return g==human?h=scores.human:g==ai?h=scores.ai:"tie"==g&&(h=scores.tie),h-20*m}if(0==f)return evalStaticBoard()-20*m;if(n){let i=-1/0;for(let d=0;d<7;d++){let j=getAvailableRow(d);if(null!=j&&""==a[j][d]){a[j][d]=ai;let o=minimaxABP(a,f-1,!1,b,c);if(a[j][d]="",i=Math.max(i,o),b=Math.max(b,i),c<=b)break}}return i}{let k=1/0;for(let e=0;e<7;e++){let l=getAvailableRow(e);if(null!=l&&""==a[l][e]){a[l][e]=human;let p=minimaxABP(a,f-1,!0,b,c);if(a[l][e]="",k=Math.min(k,p),c=Math.min(c,k),c<=b)break}}return k}}